use warnings;
use strict;

package MT::Blog::FixPingUpdate;

use Encode;
use MT::Blog;
use base qw/ MT::Blog /;

sub name {
	my $self = shift;
	Encode::encode('utf8', $self->SUPER::name);
}

sub site_url {
	my $self = shift;
	Encode::encode('utf8', $self->SUPER::site_url);
}

package MT::FixPingUpdate;

no warnings 'redefine';

use MT::XMLRPC;
my $ping_update = \&MT::XMLRPC::ping_update;
*MT::XMLRPC::ping_update = sub {
    my ($class, $method, $blog) = (shift, shift, shift);

    if (! ref($blog)) {
        require MT::Blog;
        $blog = MT::Blog->load($blog)
            or return $class->error(MT->translate('Can\'t load blog #[_1].', $blog));
    }
	bless($blog, 'MT::Blog::FixPingUpdate');

	$ping_update->($class, $method, $blog, @_);
};

1;
